#version 450 core

layout(lines) in;
layout(line_strip,max_vertices=2) out;

in Vertex {
    int instance;
  } In[];

layout (std430,binding=1) buffer meshhe { ivec4 mhe[]; } mhe;

#define FHEMASK  0x01FFFFFF
#define OTHE w

uniform TransBlock {
    mat4 mm, mmti, vpm;
    vec4 eyepos;
  } trb;

void main ( void )
{
  int i;

  i = In[0].instance;
  if ( mhe.mhe[i].OTHE > i ) {
    for ( i = 0; i < 2; i++ ) {
      gl_Position = trb.vpm * (trb.mm * gl_in[i].gl_Position);
      EmitVertex ();
    }
    EndPrimitive ();
  }
} /*main*/


