#version 450 core

layout(location=0) in vec4 in_Position;

layout (std430,binding=0) buffer meshvf { int mvf[];   } mvf;
layout (std430,binding=1) buffer meshhe { ivec4 mhe[]; } mhe;
layout (std430,binding=2) buffer meshvc { float vc[];  } mvc;

uniform int nsattr, nv, nhe, nfac;

#define FHEMASK  0x01FFFFFF
#define V0       x
#define mfac(I)  mvf.mvf[nv+(I)]
#define mfhei(I) mvf.mvf[nv+nfac+nhe+(I)]

#define FetchVertex(I) \
  switch ( nsattr ) { \
case 2: \
    gl_Position = vec4( mvc.vc[2*(I)], mvc.vc[2*(I)+1], 0.0, 1.0 );  break; \
case 3: \
    gl_Position = vec4( mvc.vc[3*(I)], mvc.vc[3*(I)+1], mvc.vc[3*(I)+2], \
                        1.0 );  break; \
default: \
    gl_Position = vec4( mvc.vc[4*(I)], mvc.vc[4*(I)+1], mvc.vc[4*(I)+2], \
                        mvc.vc[4*(I)+3] );  break; \
  }

void main ( void )
{
  int i;

  i = mhe.mhe[mfhei((mfac(gl_InstanceID) & FHEMASK) + gl_VertexID)].V0;
  FetchVertex ( i );
} /*main*/

