
#define WDGSTATE_KW_MOVING_KNOT      10
#define WDGSTATE_KW_MOVING_MOUSE     11
#define WDGSTATE_KW_PANNING          12
#define WDGSTATE_KW_ZOOMING          13

#define WDGMSG_KNOT_CHANGE           16
#define WDGMSG_KNOT_INSERT           17
#define WDGMSG_KNOT_DELETE           18
#define WDGMSG_KNOT_MCLICK           19
#define WDGMSG_KNOT_MMOVE            20
#define WDGMSG_KNOT_CHANGE_MAPPING   21
#define WDGMSG_KNOT_ERROR            22

#define XWP_KW_COLOUR         XWP_GREY_25
#define XWP_ACTIVE_KW_COLOUR  XWP_GREY_10
#define XWP_AXIS              XWP_GREY_75

typedef struct xKnotsWidgetf {
          xwidget wdg;
          int     minknots, maxknots, nknots, current, prevc;
          int     prevxi, curxi;
          int     thebutton;
          float   *knots;
          float   xmin, xmax, ximin, ximax, xc;
          char    editswitch, panswitch;
        } xKnotsWidgetf;

xKnotsWidgetf *NewKnotsWidget ( xwinmenu *wm, int id, int w, int h, int x, int y,
                                int minknots, int maxknots,
                                int nknots, float *knots, float xmin, float xmax );

int KnotsWidgetXtoXi ( xKnotsWidgetf *knw, float x );
float KnotsWidgetXitoX ( xKnotsWidgetf *knw, int xi );
int FindKnotInterval ( float n, float *knots, float x );

