
#define APP3_MAJOR         4
#define APP3_MINOR         5

#define WIN0_WIDTH       560
#define WIN0_HEIGHT      420
#define MENU1_WIDTH      120
#define MENU3_HEIGHT      60

#define BTN_ID_EXIT        1
#define SW_ID_MESH0        2
#define SW_ID_MESH1        3
#define SW_ID_MESH2        4
#define SW_ID_MESH3        5
#define SW_ID_MESH4        6
#define SL_ID_ARTP0        7  /* reserve 21 slidebar identifiers */

#define GLWIN_ID_VIEW     28

#define KNOTWD_ID         29
#define BTN_ID_PLAY       30
#define BTN_ID_LEFT       31
#define BTN_ID_SET        32
#define BTN_ID_RIGHT      33
#define SW_ID_EDIT_KNOTS  35
#define SW_ID_KNW_PANZOOM 34
#define SW_ID_ANIMATE_KL  36
#define SW_ID_ANIMATE_MM  37
#define SW_ID_ANIMATE_VP  38

#define WDGSTATE_VIEW_TURNING 1

extern Window        window[4];
extern int           window0_width, window0_height;
extern Atom          aAnimate;
extern xwinmenu      *wm1, *wm2, *wm3;
extern xwidget       *mywdg, *playbtn;
extern xKnotsWidgetf *myknotwdg;

void InitMyObject ( void );
void DestroyMyObject ( void );

void InitMyGLXWindow ( int argc, char **argv,
                       int major, int minor, int width, int height );
int main ( int argc, char **argv );
